# -*-Perl-*-
# $Id: company.pm,v 1.4 2000/01/18 19:02:41 hans Exp $

package company;
use Exporter;
@ISA = qw ( Exporter );

sub new {
    my $type = shift;
    my %params = @_;
    my $self = {};
    foreach $key (keys %params) {
	$self->{$key} = $params{$key};
    }
    bless $self;
    return $self;
}

sub display {
    my $self = shift;
    my @keys = @_ ? @_ : sort keys %$self;
    foreach $key (@keys) {
	print "\t$key => $self->{$key}\n";
    }
}


sub compnametolink {
    my ($name, $path) = @_;
    my ($see, $seeref);

    if ($series eq "serfile") {$path = "../"};
    ( $see, $seeref ) = split("#", $name);
    return "<a href=\"$path" . &main::strip_name($see) . ".html" . 
	($seeref ? "#" . &main::strip_name($seeref) : "") . "\">$see</a>";
}

#
# Simple attributes
#

sub addcompname {
    my $self = shift;
    my ( $compname ) = @_;
    $self->{"compname"} = $compname;
}

sub compname {
    my $self = shift;
    return $self->{"compname"};
}

sub addurl {
    my $self = shift;
    my ( $url ) = @_;
    $self->{"url"} = $url;
}

sub url {
    my $self = shift;
    return $self->{"url"};
}

sub addcompdesc {
    my $self = shift;
    my ( $compdesc ) = @_;
    $self->{"compdesc"} = $compdesc;
}

sub compdesc {
    my $self = shift;
    return $self->{"compdesc"};
}

sub addlogo {
    my $self = shift;
    my ( $logo ) = @_;
    $self->{"logo"} = $logo;
}

sub logo {
    my $self = shift;
    return $self->{"logo"};
}


#
# List attributes
#

sub adddistby {
    my $self = shift;
    my ( $distby ) = @_;
    push(@{$self->{"distby"}}, compnametolink($distby));
}

sub distby {
    my $self = shift;
    return @{$self->{"distby"}};
}

sub adddist {
    my $self = shift;
    my ( $dist ) = @_;
    push(@{$self->{"dist"}}, compnametolink($dist));
}

sub dist {
    my $self = shift;
    return @{$self->{"dist"}};
}

sub addlink {
    my $self = shift;
    my ( $link, $linkname ) = @_;
    push(@{$self->{"link"}}, $link);
    push(@{$self->{"linkname"}}, $linkname);
}

sub link {
    my $self = shift;
    return @{$self->{"link"}};
}

sub linkname {
    my $self = shift;
    return @{$self->{"linkname"}};
}

sub addsee {
    my $self = shift;
    my ( $see ) = @_;
    push(@{$self->{"see"}}, compnametolink($see));
}

sub see {
    my $self = shift;
    return @{$self->{"see"}};
}

sub addemail {
    my $self = shift;
    my ( $email, $emailname ) = @_;

    push(@{$self->{"email"}}, $email);
    push(@{$self->{"emailname"}}, $emailname);
}

sub email {
    my $self = shift;
    return @{$self->{"email"}};
}

sub emailname {
    my $self = shift;
    return @{$self->{"emailname"}};
}

sub makemaillink {
    my ($email, $name) = @_;

    return "<a href=\"mailto:$email\">" . ($name ? $name : $email) . "</a>";
}

sub emaillink {
    my $self = shift;
    my ($noemail, @links, @emails, @emailnames, $i, $link);

    $noemail = $#{$self->{"email"}} + 1;
    @emails = @{$self->{"email"}};
    @emailnames = @{$self->{"emailname"}};
    for ($i = 0; $i < $noemail; $i++) {
	$link = &makemaillink($emails[$i], $emailnames[$i]);
	push(@links, $link);
    }
    return @links;
}

